/*
 * Kurohige ver.1.0
 * Copyright (C) 2001-2002 by triring
 * Kurohige.java
 */

// package Kurohige;

import java.util.Random;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.ConnectionException;

// NqQQ[̃CvO
public class Kurohige extends IApplication {
    private KurohigeScreen     screen;
    private KurohigeController controller;

    public void start() {
        // ʂ𐶐
        screen = new KurohigeScreen();
        // 䕔𐶐Aʂƌт
        controller = new KurohigeController(screen);
        // fBXvCɕ\
        Display.setCurrent(screen);
    }
}

// NqQ̐vO
class KurohigeController implements SoftKeyListener, KeyListener {
    KurohigeScreen screen;
    int count = 0;
    boolean runStatus = false;

    public KurohigeController(KurohigeScreen screen) {
        this.screen = screen;

        // \tgL[Xiݒ
        screen.setSoftKeyListener(this);
        // L[Xiݒ
        screen.setKeyListener(this);
    }

    // \tgL[Xi
    public void softKeyPressed(int key) {
       if (key == Frame.SOFT_KEY_1) {
          if (runStatus == false) {
             screen.setSoftLabel(Frame.SOFT_KEY_1, "Stop");
             runStatus = true;         // stO
             /*
             theTimer.setRepeat(true);
             try {
                theTimer.start();
             } catch (UIException uie) {
             }
             */
             count = 0;
             screen.reset();
             // Ԍvłm点
         //  apA6.play(); // PiƂ쉹 1760Hz
         } else {
            screen.setSoftLabel(Frame.SOFT_KEY_1, "Start");
            runStatus = false;         // stO
         // theTimer.setRepeat(false);
         // theTimer.stop();
         }
       }
       // \tgL[2ꂽI
       if (key == Frame.SOFT_KEY_2) {
          IApplication.getCurrentApp().terminate();
       }
    }

    public void softKeyReleased(int key) { }

    /**
    * L[ꂽƂɌĂ΂
    *
    * @param panel:Panel L[ꂽƂ̃Jgpl
    * @param key:int ꂽL[̒liDisplayNXŒ`Ắj
    */
    public void keyPressed(Panel panel, int key) { }

    /**
    * L[ꂽƂɌĂ΂
    *
    * @param panel:Panel L[ꂽƂ̃Jgpl
    * @param key:int ꂽL[̒liDisplayNXŒ`Ắj
    */
    public void keyReleased(Panel panel, int key) {
       if (runStatus != true) return;
       int status = 0;
       switch(key){
          case Display.KEY_1: status = screen.pushKey(0); break;
          case Display.KEY_2: status = screen.pushKey(1); break;
          case Display.KEY_3: status = screen.pushKey(2); break;
          case Display.KEY_4: status = screen.pushKey(3); break;
          case Display.KEY_5: status = screen.pushKey(4); break;
          case Display.KEY_6: status = screen.pushKey(5); break;
          case Display.KEY_7: status = screen.pushKey(6); break;
          case Display.KEY_8: status = screen.pushKey(7); break;
          case Display.KEY_9: status = screen.pushKey(8); break;
          default           :                             break;
       }
       switch (status) {
          case  1 :                      break;
          case  0 :                      break;
          case -1 : screen.BombGoOff(); 
                    runStatus = false;   
                    screen.setSoftLabel(Frame.SOFT_KEY_1, "Start");
                    break;
       }
    }
}

// NqQQ[@\pl
class KurohigeScreen extends Panel {
   private static Random         rnd;
   AudioPresenter apSousou;      // AudioPresenter (to present the MIDI file)
   AudioPresenter apPinpon;      // AudioPresenter (to present the MIDI file)
   AudioPresenter apPipo;        // AudioPresenter (to present the MIDI file)

// Label   lblHat;               // 
   Label   lblFace;              // 
   TextBox txtBoxBody;           // 
   Label   lblMessage;           // 

   class keyPad {
      char key;
      int  status;
      keyPad(char key, int status) {
         this.key    = key;
         this.status = status;
      }

      void setStatus(int status) { this.status = status; }
      void setKey(char key)      { this.key    = key;    }
      int  getStatus() {
         switch (this.status) {
            case  1 : Mistake();       this.key = ' '; break; // JĂ鎞́CȂB
            case  0 : this.status = 1; this.key = ' '; 
                      Safe();
                      break; // J̏ꍇ́CJƂB
            case -1 :                  this.key = 'x'; break; // bomb 
         }
         return this.status;
      }
      char getKey() {
         char result = ' ';
         switch (status) {
            case  1 : result = ' ';      break; // JĂ
            case  0 : result = this.key; break; // J
            case -1 : result = this.key; break; // bomb 
         }
         return result;
      }
   }

   keyPad[] keyArray = new keyPad[9];

   KurohigeScreen () {
      keyArray[0] = new keyPad('1', 0);
      keyArray[1] = new keyPad('2', 0);
      keyArray[2] = new keyPad('3', 0);
      keyArray[3] = new keyPad('4', 0);
      keyArray[4] = new keyPad('5', 0);
      keyArray[5] = new keyPad('6', 0);
      keyArray[6] = new keyPad('7', 0);
      keyArray[7] = new keyPad('8', 0);
      keyArray[8] = new keyPad('9', 0);

      rnd         = new Random();

   // lblHat      = new Label("  _|~|_  ");
      lblFace     = new Label("  (^_^;) ");
      txtBoxBody  = new TextBox("[1][2][3]\n" +
                               "[4][5][6]\n" +
                               "[7][8][9]", 10, 3, 0);
      lblMessage  = new Label("Push Start!");

      txtBoxBody.setEditable(false); // ҏWsɂĂ

      // @햼擾
      System.out.println("microedition.platform = " + System.getProperty("microedition.platform"));
      String platform = System.getProperty("microedition.platform");
   // if (DOCOMO_EMU) {
      if (platform.equals("reference")) {
         apSousou = AudioLoader.createAudio("sousou.mid");
         apPinpon = AudioLoader.createAudio("pinpon.mid");
         apPipo   = AudioLoader.createAudio("pipo.mid"  );
      } else {
         apSousou = AudioLoader.createAudio("sousou.mld");
         apPinpon = AudioLoader.createAudio("pinpon.mld");
         apPipo   = AudioLoader.createAudio("pipo.mld"  );
      }

   // add(lblHat    );
      add(lblFace   );
      add(txtBoxBody);
      add(lblMessage);

      // ^Cgݒ
      setTitle("qQ Q[");
      setSoftLabel(Frame.SOFT_KEY_1, "Start");
      // IL[\
      setSoftLabel(Frame.SOFT_KEY_2, "Exit");
      reset();
   }

   void keyDisplay() {
      String str = "[" + keyArray[0].getKey() + "]"   +
                   "[" + keyArray[1].getKey() + "]"   +
                   "[" + keyArray[2].getKey() + "]\n" +
                   "[" + keyArray[3].getKey() + "]"   +
                   "[" + keyArray[4].getKey() + "]"   +
                   "[" + keyArray[5].getKey() + "]\n" +
                   "[" + keyArray[6].getKey() + "]"   +
                   "[" + keyArray[7].getKey() + "]"   +
                   "[" + keyArray[8].getKey() + "]";
      txtBoxBody.setText(str);
   }

   int pushKey(int key) {
      int status = keyArray[key].getStatus();
      keyDisplay();
      return status;
   }

   void reset() {
      // JĂȂԂɂB
      keyArray[0].setStatus(0); keyArray[0].setKey('1');
      keyArray[1].setStatus(0); keyArray[1].setKey('2');
      keyArray[2].setStatus(0); keyArray[2].setKey('3');
      keyArray[3].setStatus(0); keyArray[3].setKey('4');
      keyArray[4].setStatus(0); keyArray[4].setKey('5');
      keyArray[5].setStatus(0); keyArray[5].setKey('6');
      keyArray[6].setStatus(0); keyArray[6].setKey('7');
      keyArray[7].setStatus(0); keyArray[7].setKey('8');
      keyArray[8].setStatus(0); keyArray[8].setKey('9');

      keyDisplay();
      /** Generate a pseudo-random number between 0 and 9. */
      int n = Math.abs(rnd.nextInt() % 9);
      keyArray[n].setStatus(-1); // bombZbgB
      lblFace.setText("  (^_^;) ");
      lblMessage.setText("Push Start!");
   }

   void Mistake() {
      apPipo.play(); // łɊJĂƂ́@ƂB
   }

   void Safe() {
      int n;
      n = Math.abs(rnd.nextInt() % 5);
      switch (n) {
         case 0 : lblFace.setText("  (^o^)  "); break;
         case 1 : lblFace.setText("  (^_-)  "); break;
         case 2 : lblFace.setText("  (~_~)  "); break;
         case 3 : lblFace.setText("  (=_=;) "); break;
         case 4 : lblFace.setText("  (^_^;) "); break;
      }
      n = Math.abs(rnd.nextInt() % 5);
      switch (n) {
         case 0 : lblMessage.setText("Ђ[@@"); break;
         case 1 : lblMessage.setText("ȂȂ"); break;
         case 2 : lblMessage.setText("Z[t@@@"); break;
         case 3 : lblMessage.setText("[܁@"); break;
         case 4 : lblMessage.setText("nYI@"); break;
      }
      apPinpon.play(); // NA
   }

   void BombGoOff() {
      lblFace.setText("  (*_*); ");
      lblMessage.setText("Game Over!");
      apSousou.play(); // si
   }
}
